%% TEAM Model (Negative current performs OFF switching)
% Without window function

function [v,i,x,Rt] = team_op_model(v_input,t_vec,x_init,iv,input_parameters)

%Fill parameters here
%---------------------------

Roff    = 
Ron     = 
koff    = 
kon     = 
aoff    = 
aon     = 
ioff    = %Must be negative;
ion     = %Must be positive;
D       = 
xoff    = 0;
xon     = D;
%---------------------------


i=zeros(length(t_vec),1);

v=v_input;
lambda=reallog(Ron/Roff);

x(1)=x_init;
Rt = zeros(1,length(t_vec));

for j=1:length(t_vec)
    if j==1
        x(j)=x_init;
        if iv==0
            Rt(j)=(Roff+((Ron-Roff)/(xon-xoff))*(x(j)-xoff));
            i(j)=v(j)/Rt(j);
        elseif iv==1
            Rt(j)=(Roff*exp(lambda*(x(j)-xoff)/(xon-xoff)));
            i(j)=v(j)/Rt(j);
        end
    else 
        dt=t_vec(j)-t_vec(j-1);
        if i(j-1)<=ioff
            dxdt(j)=(koff*((i(j-1)/ioff-1))^aoff);
            x(j)=x(j-1)+dxdt(j)*dt;
        elseif i(j-1)>=ion
            dxdt(j)=(kon*((i(j-1)/ion)-1)^aon);
            x(j)=x(j-1)+dxdt(j)*dt;
        else
            dxdt(j)=0;
            x(j)=x(j-1);
        end

        if (x(j)<0)
            x(j)=0;
            dxdt(j)=0;
        elseif (x(j) > D) 
            x(j)=D;
            dxdt(j)=0;
        end
    
        if iv==0
            Rt(j) = (Roff+((Ron-Roff)/(xon-xoff))*(x(j)-xoff));
            i(j)=v(j)/Rt(j);
        elseif iv==1
            Rt(j)=(Roff*exp(lambda*(x(j)-xoff)/(xon-xoff)));
            i(j)=v(j)/Rt(j);
        end
    end
end

end


