%% TEAM MODEL

function [v,i,x] = team_model(v_input,t_vec,x_init,iv)

%Fill parameters here
%---------------------------

Roff    = 
Ron     = 
koff    = 
kon     = 
aoff    = 
aon     = 
ioff    = %Must be positive;
ion     = %Must be negative;
D       = 
xoff    = D;
xon     = 0;
%---------------------------

v=v_input;
lambda=reallog(Roff/Ron);

for j=1:length(t_vec)
    if j==1
        x(j)=x_init;
        if iv==0
            i(j)=v(j)/(Ron+((Roff-Ron)/(xoff-xon))*(x(j)-xon));
        elseif iv==1
            i(j)=v(j)/(Ron*exp(lambda*(x(j)-xon)/(xoff-xon)));
        end
    else
        dt = t_vec(j)-t_vec(j-1);
        if i(j-1)>=ioff
            dxdt(j)=(koff*((i(j-1)/ioff)-1)^aoff);
            x(j)=x(j-1)+dxdt(j)*dt;
        elseif i(j-1)<=ion
            dxdt(j)=kon*((abs(i(j-1)/ion)-1)^aon);
            x(j)=x(j-1)+dxdt(j)*dt;
        else
            x(j)=x(j-1);
            dxdt(j)=0;
        end
        if (x(j)<0)
            x(j)=0;
            dxdt(j)=0;
        elseif (x(j) > D) 
            x(j)=D;
            dxdt(j)=0;
        end
    
        if iv==0
            i(j)=v(j)/(Ron+((Roff-Ron)/(xoff-xon))*(x(j)-xon));
        elseif iv==1
            i(j)=v(j)/(Ron*exp(lambda*(x(j)-xon)/(xoff-xon)));
        end
    end

    
    
end


end